git-fetch.shon commit Defaulting fetch to origin when set in the repo-config (5e27e27)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5. git-sh-setup
   6. git-parse-remote
   7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   9
  10LF='
  11'
  12IFS="$LF"
  13
  14rloga=fetch
  15no_tags=
  16tags=
  17append=
  18force=
  19verbose=
  20update_head_ok=
  21exec=
  22upload_pack=
  23keep=--thin
  24while case "$#" in 0) break ;; esac
  25do
  26        case "$1" in
  27        -a|--a|--ap|--app|--appe|--appen|--append)
  28                append=t
  29                ;;
  30        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  31        --upload-pa|--upload-pac|--upload-pack)
  32                shift
  33                exec="--exec=$1" 
  34                upload_pack="-u $1"
  35                ;;
  36        -f|--f|--fo|--for|--forc|--force)
  37                force=t
  38                ;;
  39        -t|--t|--ta|--tag|--tags)
  40                tags=t
  41                ;;
  42        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  43                no_tags=t
  44                ;;
  45        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  46        --update-he|--update-hea|--update-head|--update-head-|\
  47        --update-head-o|--update-head-ok)
  48                update_head_ok=t
  49                ;;
  50        -v|--verbose)
  51                verbose=Yes
  52                ;;
  53        -k|--k|--ke|--kee|--keep)
  54                keep=--keep
  55                ;;
  56        --reflog-action=*)
  57                rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
  58                ;;
  59        -*)
  60                usage
  61                ;;
  62        *)
  63                break
  64                ;;
  65        esac
  66        shift
  67done
  68
  69case "$#" in
  700)
  71        test -f "$GIT_DIR/branches/origin" ||
  72                test -f "$GIT_DIR/remotes/origin" ||
  73                        git-repo-config --get remote.origin.url >/dev/null ||
  74                                die "Where do you want to fetch from today?"
  75        set origin ;;
  76esac
  77
  78remote_nick="$1"
  79remote=$(get_remote_url "$@")
  80refs=
  81rref=
  82rsync_slurped_objects=
  83
  84rloga="$rloga $remote_nick"
  85test "$remote_nick" = "$remote" || rloga="$rloga $remote"
  86
  87if test "" = "$append"
  88then
  89        : >"$GIT_DIR/FETCH_HEAD"
  90fi
  91
  92append_fetch_head () {
  93    head_="$1"
  94    remote_="$2"
  95    remote_name_="$3"
  96    remote_nick_="$4"
  97    local_name_="$5"
  98    case "$6" in
  99    t) not_for_merge_='not-for-merge' ;;
 100    '') not_for_merge_= ;;
 101    esac
 102
 103    # remote-nick is the URL given on the command line (or a shorthand)
 104    # remote-name is the $GIT_DIR relative refs/ path we computed
 105    # for this refspec.
 106
 107    # the $note_ variable will be fed to git-fmt-merge-msg for further
 108    # processing.
 109    case "$remote_name_" in
 110    HEAD)
 111        note_= ;;
 112    refs/heads/*)
 113        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 114        note_="branch '$note_' of " ;;
 115    refs/tags/*)
 116        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 117        note_="tag '$note_' of " ;;
 118    refs/remotes/*)
 119        note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
 120        note_="remote branch '$note_' of " ;;
 121    *)
 122        note_="$remote_name of " ;;
 123    esac
 124    remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
 125        remote_="$remote_1_"
 126    note_="$note_$remote_"
 127
 128    # 2.6.11-tree tag would not be happy to be fed to resolve.
 129    if git-cat-file commit "$head_" >/dev/null 2>&1
 130    then
 131        headc_=$(git-rev-parse --verify "$head_^0") || exit
 132        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 133        [ "$verbose" ] && echo >&2 "* committish: $head_"
 134        [ "$verbose" ] && echo >&2 "  $note_"
 135    else
 136        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 137        [ "$verbose" ] && echo >&2 "* non-commit: $head_"
 138        [ "$verbose" ] && echo >&2 "  $note_"
 139    fi
 140    if test "$local_name_" != ""
 141    then
 142        # We are storing the head locally.  Make sure that it is
 143        # a fast forward (aka "reverse push").
 144        fast_forward_local "$local_name_" "$head_" "$note_"
 145    fi
 146}
 147
 148fast_forward_local () {
 149    mkdir -p "$(dirname "$GIT_DIR/$1")"
 150    case "$1" in
 151    refs/tags/*)
 152        # Tags need not be pointing at commits so there
 153        # is no way to guarantee "fast-forward" anyway.
 154        if test -f "$GIT_DIR/$1"
 155        then
 156                if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
 157                then
 158                        [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
 159                else
 160                        echo >&2 "* $1: updating with $3"
 161                        git-update-ref -m "$rloga: updating tag" "$1" "$2"
 162                fi
 163        else
 164                echo >&2 "* $1: storing $3"
 165                git-update-ref -m "$rloga: storing tag" "$1" "$2"
 166        fi
 167        ;;
 168
 169    refs/heads/* | refs/remotes/*)
 170        # $1 is the ref being updated.
 171        # $2 is the new value for the ref.
 172        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 173        if test "$local"
 174        then
 175            # Require fast-forward.
 176            mb=$(git-merge-base "$local" "$2") &&
 177            case "$2,$mb" in
 178            $local,*)
 179                if test -n "$verbose"
 180                then
 181                        echo >&2 "* $1: same as $3"
 182                fi
 183                ;;
 184            *,$local)
 185                echo >&2 "* $1: fast forward to $3"
 186                echo >&2 "  from $local to $2"
 187                git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
 188                ;;
 189            *)
 190                false
 191                ;;
 192            esac || {
 193                echo >&2 "* $1: does not fast forward to $3;"
 194                case ",$force,$single_force," in
 195                *,t,*)
 196                        echo >&2 "  forcing update."
 197                        git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
 198                        ;;
 199                *)
 200                        echo >&2 "  not updating."
 201                        exit 1
 202                        ;;
 203                esac
 204            }
 205        else
 206            echo >&2 "* $1: storing $3"
 207            git-update-ref -m "$rloga: storing head" "$1" "$2"
 208        fi
 209        ;;
 210    esac
 211}
 212
 213case "$update_head_ok" in
 214'')
 215        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 216        ;;
 217esac
 218
 219# If --tags (and later --heads or --all) is specified, then we are
 220# not talking about defaults stored in Pull: line of remotes or
 221# branches file, and just fetch those and refspecs explicitly given.
 222# Otherwise we do what we always did.
 223
 224reflist=$(get_remote_refs_for_fetch "$@")
 225if test "$tags"
 226then
 227        taglist=`IFS="  " &&
 228                  git-ls-remote $upload_pack --tags "$remote" |
 229                  while read sha1 name
 230                  do
 231                        case "$name" in
 232                        *^*) continue ;;
 233                        esac
 234                        if git-check-ref-format "$name"
 235                        then
 236                            echo ".${name}:${name}"
 237                        else
 238                            echo >&2 "warning: tag ${name} ignored"
 239                        fi
 240                  done`
 241        if test "$#" -gt 1
 242        then
 243                # remote URL plus explicit refspecs; we need to merge them.
 244                reflist="$reflist$LF$taglist"
 245        else
 246                # No explicit refspecs; fetch tags only.
 247                reflist=$taglist
 248        fi
 249fi
 250
 251fetch_main () {
 252  reflist="$1"
 253  refs=
 254
 255  for ref in $reflist
 256  do
 257      refs="$refs$LF$ref"
 258
 259      # These are relative path from $GIT_DIR, typically starting at refs/
 260      # but may be HEAD
 261      if expr "z$ref" : 'z\.' >/dev/null
 262      then
 263          not_for_merge=t
 264          ref=$(expr "z$ref" : 'z\.\(.*\)')
 265      else
 266          not_for_merge=
 267      fi
 268      if expr "z$ref" : 'z+' >/dev/null
 269      then
 270          single_force=t
 271          ref=$(expr "z$ref" : 'z+\(.*\)')
 272      else
 273          single_force=
 274      fi
 275      remote_name=$(expr "z$ref" : 'z\([^:]*\):')
 276      local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
 277
 278      rref="$rref$LF$remote_name"
 279
 280      # There are transports that can fetch only one head at a time...
 281      case "$remote" in
 282      http://* | https://*)
 283          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 284              curl_extra_args="-k"
 285          fi
 286          max_depth=5
 287          depth=0
 288          head="ref: $remote_name"
 289          while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
 290          do
 291            remote_name_quoted=$(@@PERL@@ -e '
 292              my $u = $ARGV[0];
 293              $u =~ s/^ref:\s*//;
 294              $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 295              print "$u";
 296          ' "$head")
 297            head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
 298            depth=$( expr \( $depth + 1 \) )
 299          done
 300          expr "z$head" : "z$_x40\$" >/dev/null ||
 301              die "Failed to fetch $remote_name from $remote"
 302          echo >&2 Fetching "$remote_name from $remote" using http
 303          git-http-fetch -v -a "$head" "$remote/" || exit
 304          ;;
 305      rsync://*)
 306          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 307          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 308          head=$(git-rev-parse --verify TMP_HEAD)
 309          rm -f "$TMP_HEAD"
 310          test "$rsync_slurped_objects" || {
 311              rsync -av --ignore-existing --exclude info \
 312                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 313
 314              # Look at objects/info/alternates for rsync -- http will
 315              # support it natively and git native ones will do it on
 316              # the remote end.  Not having that file is not a crime.
 317              rsync -q "$remote/objects/info/alternates" \
 318                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 319                  rm -f "$GIT_DIR/TMP_ALT"
 320              if test -f "$GIT_DIR/TMP_ALT"
 321              then
 322                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 323                  while read alt
 324                  do
 325                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 326                      echo >&2 "Getting alternate: $alt"
 327                      rsync -av --ignore-existing --exclude info \
 328                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 329                  done
 330                  rm -f "$GIT_DIR/TMP_ALT"
 331              fi
 332              rsync_slurped_objects=t
 333          }
 334          ;;
 335      *)
 336          # We will do git native transport with just one call later.
 337          continue ;;
 338      esac
 339
 340      append_fetch_head "$head" "$remote" \
 341          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 342
 343  done
 344
 345  case "$remote" in
 346  http://* | https://* | rsync://* )
 347      ;; # we are already done.
 348  *)
 349    ( : subshell because we muck with IFS
 350      IFS="     $LF"
 351      (
 352          git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
 353      ) |
 354      while read sha1 remote_name
 355      do
 356          case "$sha1" in
 357          failed)
 358                  echo >&2 "Fetch failure: $remote"
 359                  exit 1 ;;
 360          esac
 361          found=
 362          single_force=
 363          for ref in $refs
 364          do
 365              case "$ref" in
 366              +$remote_name:*)
 367                  single_force=t
 368                  not_for_merge=
 369                  found="$ref"
 370                  break ;;
 371              .+$remote_name:*)
 372                  single_force=t
 373                  not_for_merge=t
 374                  found="$ref"
 375                  break ;;
 376              .$remote_name:*)
 377                  not_for_merge=t
 378                  found="$ref"
 379                  break ;;
 380              $remote_name:*)
 381                  not_for_merge=
 382                  found="$ref"
 383                  break ;;
 384              esac
 385          done
 386          local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
 387          append_fetch_head "$sha1" "$remote" \
 388                  "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 389      done
 390    ) || exit ;;
 391  esac
 392
 393}
 394
 395fetch_main "$reflist"
 396
 397# automated tag following
 398case "$no_tags$tags" in
 399'')
 400        case "$reflist" in
 401        *:refs/*)
 402                # effective only when we are following remote branch
 403                # using local tracking branch.
 404                taglist=$(IFS=" " &&
 405                git-ls-remote $upload_pack --tags "$remote" |
 406                sed -ne 's|^\([0-9a-f]*\)[      ]\(refs/tags/.*\)^{}$|\1 \2|p' |
 407                while read sha1 name
 408                do
 409                        test -f "$GIT_DIR/$name" && continue
 410                        git-check-ref-format "$name" || {
 411                                echo >&2 "warning: tag ${name} ignored"
 412                                continue
 413                        }
 414                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 415                        echo >&2 "Auto-following $name"
 416                        echo ".${name}:${name}"
 417                done)
 418        esac
 419        case "$taglist" in
 420        '') ;;
 421        ?*)
 422                fetch_main "$taglist" ;;
 423        esac
 424esac
 425
 426# If the original head was empty (i.e. no "master" yet), or
 427# if we were told not to worry, we do not have to check.
 428case ",$update_head_ok,$orig_head," in
 429*,, | t,* )
 430        ;;
 431*)
 432        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 433        if test "$curr_head" != "$orig_head"
 434        then
 435            git-update-ref \
 436                        -m "$rloga: Undoing incorrectly fetched HEAD." \
 437                        HEAD "$orig_head"
 438                die "Cannot fetch into the current branch."
 439        fi
 440        ;;
 441esac